
#if HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef _WIN32
#include <stdio.h>
#include <errno.h>
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <windows.h>
#include "nonposix.h"

/* Rename the file OLD to NEW.  */
#ifdef rename
#undef rename
#endif

#ifndef _MSC_VER
int unlink (const char *filename)
{
	if (_access (filename, W_OK) < 0) 
		switch (errno) {
			case EINVAL:
				return -1;
				break;
			case ENOENT:
				return -1;
				break;
			case EACCES:
				_chmod (filename, _S_IREAD | _S_IWRITE);
				break;
			default:
				break;
		}
	return _unlink (filename);
}
#endif

#ifndef F_OK
#define F_OK 0
#endif

int
w32_rename (old, new)
	const char *old;
	const char *new;
{
	if (old == NULL || new == NULL) {
		errno = EINVAL;
		return -1;
	}

	if (!_access (new, F_OK))
		unlink (new);
	return rename (old, new);
}

#endif /* _WIN32 */
